.col-separator {
  border-left: 1px solid $border-color;
}

%container-common {
  @include media-breakpoint-down($cards-grid-breakpoint) {
    --#{$variable-prefix}gutter-x: #{$grid-gutter-width};
  }
}

.container,
.container-fluid {
  @extend %container-common;
}

.container {
  @each $variation, $size in $container-variations {
    &-#{$variation} {
      @include make-container();
      max-width: $size;
    }
  }
}

@each $name, $value in (0: 0, sm: .375rem, md: 1.5rem, lg: 3rem) {
  .row-#{$name} {
    margin-right: (-$value);
    margin-left: -($value);

    > .col,
    > [class*="col-"] {
      padding-right: $value;
      padding-left: $value;
    }

    .card {
      margin-bottom: 2 * $value;
    }
  }
}

.row {
  --rimow-gutter-x: 1rem;
  --rimow-gutter-y: 0;
  margin-top: calc(var(--rimow-gutter-y) * -1);
  margin-right: calc(var(--rimow-gutter-x) / -2);
  margin-left: calc(var(--rimow-gutter-x) / -2);
}

.row > * {
  min-width: 0;
  padding-right: calc(var(--rimow-gutter-x) / 2) !important;
  padding-left: calc(var(--rimow-gutter-x) / 2) !important;
  margin-top: var(--rimow-gutter-y);
}

// Bootstrap 5 gutter utilities

.g-0,
.gy-0 {
  --rimow-gutter-y: 0;
}

.g-0,
.gx-0 {
  --rimow-gutter-x: 0;
}

.g-2,
.gy-2 {
  --rimow-gutter-y: 0.5rem;
}

.g-2,
.gx-2 {
  --rimow-gutter-x: 0.5rem;
}

.row-deck {
  > .col,
  > [class*="col-"] {
    display: flex;
    align-items: stretch;

    .card {
      flex: 1 1 auto;
    }
  }
}

.row-cards {
  --#{$variable-prefix}gutter-x: #{$cards-grid-gap};
  --#{$variable-prefix}gutter-y: #{$cards-grid-gap};

  .row-cards {
    flex: 1;
  }

  @include media-breakpoint-down($cards-grid-breakpoint) {
    --#{$variable-prefix}gutter-x: #{$cards-grid-gap / 2};
    --#{$variable-prefix}gutter-y: #{$cards-grid-gap / 2};
  }
}

@each $name, $size in map-merge((null: $spacer), $spacers) {
  $name-prefixed: if($name == null, null, '-#{$name}');

  .space-y#{$name-prefixed} {
    > :not(template) ~ :not(template) {
      margin-top: $size !important;
    }
  }

  .space-x#{$name-prefixed} {
    > :not(template) ~ :not(template) {
      margin-left: $size !important;
    }
  }
}

@each $name, $size in map-merge((null: $spacer), $spacers) {
  $name-prefixed: if($name == null, null, '-#{$name}');

  .divide-y#{$name-prefixed} {
    > :not(template) ~ :not(template) {
      border-top: 1px solid $border-color-transparent !important;
    }

    > :not(template):not(:first-child) {
      padding-top: $size/2 !important;
    }

    > :not(template):not(:last-child) {
      padding-bottom: $size/2 !important;
    }
  }

  .divide-x#{$name-prefixed} {
    > :not(template) ~ :not(template) {
      border-left: 1px solid $border-color-transparent !important;
    }

    > :not(template):not(:first-child) {
      padding-left: $size/2 !important;
    }

    > :not(template):not(:last-child) {
      padding-right: $size/2 !important;
    }
  }
}